static const char default_init_scm[] =
";;\n"
";; このファイルはデフォルトで読み込まれる物と同一。\n"
";;\n"
";; ユーザが~/.ochusha/ochusha-init.scmというファイルを持っている場合、\n"
";; この内容の代わりにそれが読み込まれる。\n"
";;\n"
";; $Id: ochusha-init.scm.default,v 1.4 2008/12/16 16:19:35 fuyu Exp $\n"
";;\n"
"\n"
";; おちゅ〜しゃは色を表現するために以下の定数をあらかじめ定義しており、\n"
";; スレ一覧の色付けに使われる。これらは「おちゅ〜しゃの設定」ダイアログの\n"
";; 「一覧表示」タブで選択される色を参照する定数である。\n"
";;                                                ↓現在定義されている値\n"
";; `list-entry-fg-normal', `list-entry-bg-normal' GTK+/GNOMEテーマのデフォルト\n"
";; `list-entry-fg-emph', `list-entry-bg-emph' テーマのデフォルト、lavender\n"
";; `list-entry-fg-strong', `list-entry-bg-strong' red、テーマのデフォルト\n"
";; `list-entry-fg-hidden', `list-entry-bg-hidden' gray75、テーマのデフォルト\n"
";;\n"
";; おちゅ〜しゃのデフォルト状態ではこれらの定数を使い、スレ一覧を以下の\n"
";; ように色付けする。\n"
";; 隠されたスレ\n"
";;   => (list-entry-fg-hidden . list-entry-bg-hidden)\n"
";; DAT落ちスレ\n"
";;   => (list-entry-fg-normal . list-entry-bg-strong)\n"
";; 新スレ\n"
";;   => (list-entry-fg-emph . list-entry-bg-emph)\n"
";; 既読かつ未読レスあり\n"
";;   => (list-entry-fg-strong . list-entry-bg-strong)\n"
";; 他のスレ\n"
";;   => (list-entry-fg-normal . list-entry-bg-normal) can be shorten by '()\n"
"\n"
";; 色オブジェクトはgdk-color-parse関数によりschemeレベルで定義することも\n"
";; できる。内部的にはCのgdk_color_parse()関数を呼んでいるので、\n"
";; /usr/X11R6/lib/X11/rgb.txtあたりに書かれている色名や\"#RRGGBB\"みたいな\n"
";; 文字列で色が指定できる。エラー時は黙ってデフォルトの色になる。\n"
";(define test-fg (gdk-color-parse \"yellow\"))\n"
"\n"
"\n"
";; 以下がデフォルトのスレ一覧用色選択関数の定義\n"
"(define (decorate-list-entry-default thread)\n"
"  (let ((new-responses (thread-get-number-of-new-responses thread))\n"
"	(n-got (thread-get-number-of-responses-got thread)))\n"
"    (cond ((thread-hidden? thread)\n"
"	   (cons list-entry-fg-hidden list-entry-bg-hidden))\n"
"	  ((not (thread-alive? thread))\n"
"	   (cons list-entry-fg-normal list-entry-bg-strong))\n"
"	  ((> n-got 0)\n"
"	   (if (> (thread-get-number-of-responses-on-server thread) n-got)\n"
"	       (cons list-entry-fg-strong list-entry-bg-strong) '()))\n"
"	  ((thread-new? thread)\n"
"	   (cons list-entry-fg-normal list-entry-bg-emph))\n"
"	  (else '()))))\n"
"\n"
"\n"
";; おちゅ〜しゃはスレ一覧を飾り付けるためにdecorate-list-entryという\n"
";; 名前の関数を呼び出す。\n"
";; この関数が返した色オブジェクトのペアにより、スレ一覧の個々の要素の\n"
";; 色が決まる。\n"
";; (car (decorate-list-entry thread)) が前景色\n"
";; (cdr (decorate-list-entry thread)) が背景色\n"
";; になる。これが'()を返した場合、GTK+/GNOMEのテーマで決まるデフォルト\n"
";; の色になる。\n"
"(define decorate-list-entry decorate-list-entry-default)\n"
"\n"
"\n"
";; スレ一覧でのカーソル移動時に用いられる。\n"
";; この関数が真を返したスレは読むべきものの存在するスレとして取り扱われる。\n"
"(define (interest-thread? thread)\n"
"  (and (> (thread-get-number-of-responses-got thread) 0)\n"
"       (> (thread-get-number-of-responses-to-read thread) 0)))\n"
"\n"
"\n"
";; スレ一覧の表示規則を追加する。\n"
";; (register-threadlist-rule NAME LABEL DESCRIPTION PROCEDURE)\n"
";;\n"
";; NAMEは内部的に規則を識別するために用いられる文字列。同じ名前の規則が\n"
";; 存在していた場合、上書きされる。\n"
";; LABELはGUIのメニューなどに表示される文字列。\n"
";; DESCRIPTIONは規則の説明。\n"
";; PROCEDUREは規則を実現する関数。スレ一覧は、この関数の返した数値\n"
";; について昇順にソートされる。この関数が#fを返したスレは一覧に表示されない。\n"
";; PROCEDUREは引数としてthreadオブジェクトを一つだけ取る関数でなければならない。\n"
"(register-threadlist-rule\n"
" \"ochusha-default-plain-all\"\n"
" \"全部\"\n"
" \"現存スレ→DAT落ちスレ\"\n"
" (lambda (thread)\n"
"   (if (thread-alive? thread) 0 10000)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-plain-live-only\"\n"
" \"現存スレ\"\n"
" \"現存スレ全部\"\n"
" (lambda (thread)\n"
"   (if (thread-alive? thread) 0 #f)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-plain-dead-only\"\n"
" \"DAT落ちスレ\"\n"
" \"DAT落ちスレ全部\"\n"
" (lambda (thread)\n"
"   (if (thread-alive? thread) #f 0)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-plain-all-newer-to-older\"\n"
" \"全部新しい順\"\n"
" \"スレ全部新しい順\"\n"
" (lambda (thread)\n"
"   (- #x7fffffff (thread-get-birthtime thread))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-plain-all-older-to-newer\"\n"
" \"全部古い順\"\n"
" \"スレ全部古い順\"\n"
" (lambda (thread)\n"
"   (thread-get-birthtime thread)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-importance-order\"\n"
" \"全部重要度順\"\n"
" \"既読(未読有)→新スレ→既読(未読無)→通常スレ→DAT落スレ\"\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (+ (if (thread-hidden? thread) 10000 0)\n"
"	(if (thread-marked? thread) 0 5000)\n"
"	(if (> n-got 0)\n"
"	    (if (> n-res n-got) 0 2000)\n"
"	    (if (thread-new? thread) 1000 3000))\n"
"	(if (thread-alive? thread) 0 5000)))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-important-only\"\n"
" \"注目スレ\"\n"
" \"既読(未読有)→新スレ→既読(未読無)→既読(DAT落ち)\"\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (if (and (= n-got 0) (not (thread-marked? thread)))\n"
"	 #f\n"
"	 (+ (if (thread-marked? thread) 0 5000)\n"
"	    (if (> n-got 0)\n"
"		(if (> n-res n-got) 0 2000)\n"
"		(if (thread-new? thread) 1000 3000))\n"
"	    (if (thread-alive? thread) 0 5000))))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-important-unread-only\"\n"
" \"未読有注目スレ\"\n"
" \"既読(未読有)\"\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (if (or (= n-got 0) (<= n-res n-got))\n"
"	 #f\n"
"	 (+ (if (thread-marked? thread) 0 5000)\n"
"	    (if (thread-alive? thread) 0 5000))))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-important-live-only\"\n"
" \"現存注目スレ\"\n"
" \"既読(未読有)→既読(未読無)\"\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (if (or (and (= n-got 0)\n"
"		  (not (thread-marked? thread)))\n"
"	     (not (thread-alive? thread)))\n"
"	 #f\n"
"	 (+ (if (thread-marked? thread) 0 5000)\n"
"	    (if (> n-got 0)\n"
"		(if (> n-res n-got) 0 2000)))))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-importance-order-live-only\"\n"
" \"現存重要度順\"\n"
" \"既読(未読有)→新スレ→既読(未読無)→通常スレ\"\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (if (thread-alive? thread)\n"
"	 (+ (if (thread-hidden? thread) 10000 0)\n"
"	    (if (thread-marked? thread) 0 5000)\n"
"	    (if (> n-got 0)\n"
"		(if (> n-res n-got) 0 2000)\n"
"		(if (thread-new? thread) 1000 3000)))\n"
"	 #f))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-live-only-newer-to-older\"\n"
" \"現存新しい順\"\n"
" \"現存スレ全部新しい順\"\n"
" (lambda (thread)\n"
"   (if (thread-alive? thread)\n"
"       (- #x7fffffff (thread-get-birthtime thread)) #f)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-live-only-older-to-newer\"\n"
" \"現存古い順\"\n"
" \"現存スレ全部古い順\"\n"
" (lambda (thread)\n"
"   (if (thread-alive? thread)\n"
"       (thread-get-birthtime thread) #f)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-mark-only\"\n"
" \"印付\"\n"
" \"印付スレのみ\"\n"
" (lambda (thread)\n"
"   (if (thread-marked? thread) 0 #f)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-only-mark-is-important\"\n"
" \"印重要\"\n"
" \"印付スレ→印無スレ\"\n"
" (lambda (thread)\n"
"   (if (thread-marked? thread) 0 1000)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-marked-unread-is-important\"\n"
" \"印未読重要\"\n"
" \"印付(未読有)→印付(未読無)→通常スレ→DAT落スレ\"\n"
" (lambda (thread)\n"
"   (if (thread-marked? thread)\n"
"       (if (> (thread-get-number-of-responses-on-server thread)\n"
"	      (thread-get-number-of-responses-read thread))\n"
"	   0 1000)\n"
"       2000)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-importance-order-mark-first\"\n"
" \"印最強重要度順\"\n"
" \"印付→既読(未読有)→新スレ→既読(未読無)→通常スレ→DAT落スレ\"\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (+ (if (thread-hidden? thread) 10000 0)\n"
"	(if (thread-marked? thread) 0 20000)\n"
"	(if (> n-got 0)\n"
"	    (if (> n-res n-got) 0 2000)\n"
"	    (if (thread-new? thread) 1000 3000))\n"
"	(if (thread-alive? thread) 0 5000)))))\n"
"\n"
"\n"
";; (register-external-tool NAME LABEL DESCRIPTION TOOL-TYPE TEMPLorPROC)\n"
";;\n"
";; NAMEは内部的に規則を識別するために用いられる文字列。同じ名前のツールが\n"
";; 登録されていた場合、上書きされる。\n"
";;\n"
";; LABELはGUIのメニューなどに表示される文字列。\n"
";;\n"
";; DESCRIPTIONはツールの説明。\n"
";;\n"
";; TOOL-TYPEはツールの種別を示す。具体的には、どのメニューに現れるべきかを\n"
";; 決めるシンボル。現在内部的には、'link-tool、'image-tool、'text-tool\n"
";; が予約されており、それぞれリンクに対するポップアップメニュー、画像リンク\n"
";; に対するポップアップメニュー、選択文字列に対するポップアップメニューの\n"
";; ツールに対応する。\n"
";;\n"
";; TEMPLorPROCはコマンドラインのテンプレートを与える文字列か文字列を引数と\n"
";; して受取り、テンプレート文字列を返すprocedureとなる予定。\n"
";; テンプレートの\"%ARG%\"がURLや画像ファイルのパス名、選択中の文字列などで\n"
";; 置き換えられる。\n"
";; テンプレートに\"%FILENAME_FROM_ARG%\"もしくは\"%FILENAME%\"が現れた場合、\n"
";; コマンドライン実行の前にファイル選択用のダイアログが現れ、そこで選択\n"
";; されたファイル名で置き換えられる。\"%FILENAME_FROM_ARG%\"の場合には、\n"
";; \"%ARG%\"がファイル名の初期値として用いられ、%FILENAME%の場合は、\n"
";; localizeされた\"untitled\"相当の文字列がファイル名の初期値として用いられる。\n"
"(register-external-tool\n"
" \"save-image\"\n"
" \"名前を付けて画像を保存\"\n"
" \"名前を付けて画像を保存\"\n"
" 'image-tool\n"
" \"cp %ARG% %FILENAME_FROM_ARG%\")\n"
"\n"
";; eogの例では、引数として与えられたパス名を自前でコマンドラインに\n"
";; 展開するprocedureをTEMPLorPROCとして登録している。\n"
"(register-external-tool\n"
" \"browse-image-with-eog\"\n"
" \"Eye of GNOME\"\n"
" \"eogで画像を開く\"\n"
" 'image-tool\n"
" (lambda (filename)\n"
"   (format \"eog ~a\" filename)))\n"
"\n"
"(register-external-tool\n"
" \"browse-image-with-gimp\"\n"
" \"Gimp\"\n"
" \"gimpで画像を開く\"\n"
" 'image-tool\n"
" \"gimp-remote %ARG%\")\n"
"\n"
"\n"
";; wgetの例では、おちゅ〜しゃが%ARG%をURLに置き換えるコマンドライン\n"
";; のテンプレートをTEMPLorPROCとして登録している。\n"
"(register-external-tool\n"
" \"download-url-with-wget\"\n"
" \"Wget\"\n"
" \"WgetでURLを開く\"\n"
" 'link-tool\n"
" \"xterm -e wget %ARG%\")\n"
"\n"
"\n"
"(register-external-tool\n"
" \"open-url-with-d4x\"\n"
" \"d4x\"\n"
" \"d4xでURLを開く\"\n"
" 'link-tool\n"
" (lambda (url)\n"
"   (format \"d4x ~a\" url)))\n"
"\n"
"\n"
";; Internet Archiveの例ではウェブブラウザで開くべきURLを返すprocedureを\n"
";; TEMPLorPROCとして登録している。\n"
"(register-external-tool\n"
" \"search-archive-with-web-browser\"\n"
" \"Internet Archive Wayback Machine\"\n"
" \"Internet Archive Wayback MachineでURLを検索する\"\n"
" 'link-tool\n"
" (lambda (url)\n"
"   (format \"%WEBBROWSER% http://web.archive.org/*/~a\" url)))\n"
"\n"
"\n"
";; Googleの例ではウェブブラウザで開くべきURLを返すprocedureを\n"
";; TEMPLorPROCとして登録している。\n"
";; %E6%A4%9C%E7%B4%A2はUTF-8な\"検索\"をURIエンコードしたもの。\n"
"(register-external-tool\n"
" \"google-text-in-japanese\"\n"
" \"Google Search(日本語のページ)\"\n"
" \"日本語のページでググる\"\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://www.google.co.jp/search?hl=ja&q=~a&btnG=Google+%E6%A4%9C%E7%B4%A2&lr=lang_ja\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"google-text-in-all\"\n"
" \"Google Search(ウェブ全体)\"\n"
" \"ウェブ全体でググる\"\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://www.google.co.jp/search?hl=ja&q=~a&btnG=Google+%E6%A4%9C%E7%B4%A2&lr=\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"google-image\"\n"
" \"Google Search(イメージ)\"\n"
" \"イメージでググる\"\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://www.google.co.jp/images?hl=ja&q=~a&btnG=Google+%E3%82%A4%E3%83%A1%E3%83%BC%E3%82%B8%E6%A4%9C%E7%B4%A2&lr=\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"excite-english-japanese-dictionary\"\n"
" \"excite辞書(新英和中辞典)\"\n"
" \"excite辞書で新英和中辞典を引く\"\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://www.excite.co.jp/dictionary/english_japanese/?search=~a&submit=+%E6%A4%9C+%E7%B4%A2+&match=beginswith&dictionary=NEW_EJJE\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"excite-japanese-english-dictionary\"\n"
" \"excite辞書(新和英中辞典)\"\n"
" \"excite辞書で新和英中辞典を引く\"\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://www.excite.co.jp/dictionary/japanese_english/?search=~a&submit=+%E6%A4%9C+%E7%B4%A2+&match=beginswith\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"wikipedia-ja-search\"\n"
" \"ウィキペディア（日本語版）で検索\"\n"
" \"ウィキペディアを検索する\"\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://ja.wikipedia.org/wiki/%E7%89%B9%E5%88%A5:Search?search=~a&fulltext=%E6%A4%9C%E7%B4%A2\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"wikipedia-en-search\"\n"
" \"Wikipedia(英語版)で検索\"\n"
" \"Wikipediaを検索する\"\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://en.wikipedia.org/wiki/Special:Search?search=~a&fulltext=Search\" (url-encode-string text))))\n"
"\n"
"\n"
"\n"
";; いずれ、ユーザの好みでime.nuの類を抜き去るなどのリンクの書き換えも\n"
";; scheme関数で出来るようになる予定。\n"
"(define (rewrite-link-default link) link)\n"
"\n"
"\n"
";; おちゅ〜しゃはリンクの書き換えなどを行うために、rewrite-linkという\n"
";; 名前の関数を呼び出すようになる予定。現時点では未使用。\n"
"(define rewrite-link rewrite-link-default)\n"
"\n"
"\n"
";; GCのタイミングまでメモリがfreeされないので、output-string-portを\n"
";; 好き勝手に使いまくるのはちょいと気が引ける。なので、レス本文の\n"
";; 書き換え時には、グローバルに確保した一つのoutput-string-portを\n"
";; 使い回す。そのために(clear-output-string output-string-port)な\n"
";; 非標準的関数を追加した。\n"
"(define global-string-port (open-output-string))\n"
"\n"
"\n"
";; デフォルトの本文書き換え関数で使う。\n"
"(define (caadddr x) (car (cadddr x)))\n"
"(define (cdadddr x) (cdr (cadddr x)))\n"
"\n"
"\n"
";; これがデフォルトの本文書き換え関数。\n"
";; - httpやftpなURLっぽい文字列をHTMLのa要素風に\n"
";; - レスアンカーになっていない>数字みたいなのをレスアンカーに\n"
";; - レスアンカーに続く,数字みたいなのをレスアンカーに\n"
";; それぞれ書き換える。\n"
"(define (rewrite-message-default message)\n"
"  (letrec\n"
"      ((output (lambda (text) (display text global-string-port)))\n"
"       (rewrite-additional-response-number\n"
"	(lambda (message)\n"
"	  (let* ((match-pos\n"
"		  (regexp-match-positions #/^(?:[ ,､、，=＝]+)([0-9０-９]+)/\n"
"					  message))\n"
"		  (match-beg (if match-pos (caar match-pos) 0))\n"
"		  (match-end (if match-pos (cdar match-pos) 0))\n"
"		  (number-beg (if match-pos (caadr match-pos) 0))\n"
"		  (number-end (if match-pos (cdadr match-pos) 0)))\n"
"	    (if match-pos\n"
"		(begin (output \"<a href=\\\"\")\n"
"		       (output (substring message number-beg number-end))\n"
"		       (output \"\\\">\")\n"
"		       (output (substring message match-beg match-end))\n"
"		       (output \"</a>\")\n"
"		       (rewrite-additional-response-number\n"
"			(substring message match-end)))\n"
"		(rewrite-message message)))))\n"
"       (rewrite-non-link-response-number\n"
"	(lambda (message)\n"
"	  (let* ((match-pos\n"
"		  (regexp-match-positions\n"
"		   #/(?:&gt;|[＞≫〉》])+([0-9０-９]+[-―ー─－〜]?[0-9０-９]*)/\n"
"		   message))\n"
"		 (match-beg (if match-pos (caar match-pos) 0))\n"
"		 (match-end (if match-pos (cdar match-pos) 0))\n"
"		 (numbers-beg (if match-pos (caadr match-pos) 0))\n"
"		 (numbers-end (if match-pos (cdadr match-pos) 0)))\n"
"	    (if match-pos\n"
"		(begin (output (substring message 0 match-beg))\n"
"		       (output \"<a href=\\\"\")\n"
"		       (output (substring message numbers-beg numbers-end))\n"
"		       (output \"\\\">\")\n"
"		       (output (substring message match-beg match-end))\n"
"		       (output \"</a>\")\n"
"		       (rewrite-additional-response-number\n"
"			(substring message match-end)))\n"
"		(output message)))))\n"
"       (rewrite-non-link-url\n"
"	(lambda (message)\n"
"	  (let* ((match-pos\n"
"		  (regexp-match-positions\n"
"		   #/(h?[ft]?)tp(s?):\\/\\/([0-9a-zA-Z\\/#?;:@&%=+\\-!*$,._~'()]+)/\n"
"		   message))\n"
"		 (match-beg0 (if match-pos (caar match-pos) 0))\n"
"		 (match-end0 (if match-pos (cdar match-pos) 0))\n"
"		 (match-beg1 (if match-pos (caadr match-pos) 0))\n"
"		 (match-end1 (if match-pos (cdadr match-pos) 0))\n"
"		 (match-beg2 (if match-pos (caaddr match-pos) 0))\n"
"		 (match-end2 (if match-pos (cdaddr match-pos) 0))\n"
"		 (match-beg3 (if match-pos (caadddr match-pos) 0))\n"
"		 (match-end3 (if match-pos (cdadddr match-pos) 0)))\n"
"	    (if match-pos\n"
"		(begin (rewrite-non-link-response-number\n"
"			(substring message 0 match-beg0))\n"
"		       (output \"<a href=\\\"\")\n"
"		       (if (eqv? (substring message match-beg1 match-end1) \"f\")\n"
"			   (output \"f\")\n"
"			   (output \"ht\"))\n"
"		       (output \"tp\")\n"
"		       (output (substring message match-beg2 match-end2))\n"
"		       (output \"://\")\n"
"		       (output (substring message match-beg3 match-end3))\n"
"		       (output \"\\\">\")\n"
"		       (output (substring message match-beg0 match-end0))\n"
"		       (output \"</a>\")\n"
"		       (rewrite-non-link-url\n"
"			(substring message match-end0)))\n"
"		(rewrite-non-link-response-number message)))))\n"
"       (rewrite-message\n"
"	(lambda (message)\n"
"	  (let ((match-pos (regexp-match-positions\n"
"			    #/<[aA][[:space:]][^>]+>[^<]*<\\/a>/ message)))\n"
"	    (if match-pos\n"
"		(begin (rewrite-non-link-url\n"
"			(substring message 0 (caar match-pos)))\n"
"		       (output (substring\n"
"				message (caar match-pos) (cdar match-pos)))\n"
"		       (rewrite-additional-response-number\n"
"			(substring message (cdar match-pos))))\n"
"		(rewrite-non-link-url message))))))\n"
"    (clear-output-string global-string-port)\n"
"    (rewrite-message message)\n"
"    (get-output-string global-string-port)))\n"
"\n"
"\n"
";; おちゅ〜しゃはスレ表示の直前に各レスのメッセージ本文を引数として\n"
";; rewrite-messageという名前の関数を呼び出し、本文を書き換える。\n"
"(define rewrite-message rewrite-message-default)\n"
"\n"
"\n"
";; おちゅ〜しゃはリンクが画像のものかどうかを判断するために\n"
";; image-link?という名前の関数を呼び出す。\n"
"(define (image-link? url) #f)\n"
"\n"
"\n"
";; おちゅ〜しゃは画像のものと判断されたリンクに対し、実際にアクセスする\n"
";; URLに細工を加えることを許すためにrewrite-image-linkという名前の関数を\n"
";; 呼び出す。\n"
";; この関数の返り値はURLそのものを表す文字列もしくは\n"
";; (URL . REFERER)というペアが期待され、それ以外の値の場合にはURLへの\n"
";; 細工が必要ないものと判断される。\n"
";; (URL . REFERER)というペアが返された場合、おちゅ〜しゃは\n"
";; rewrite-image-linkの引数として与えたurlの代わりにURLにアクセスし、\n"
";; その時にHTTPのリクエストヘッダのRefererとしてREFERERを設定する。\n"
"(define (rewrite-image-link url) #f)\n"
"\n"
"\n"
";; おちゅ〜しゃは画像リンクと思ってアクセスした結果がHTMLだった時に\n"
";; それが目的の画像を表示するためのページである可能性を確認するために\n"
";; redirect-image-linkという名前の関数を呼び出す。\n"
";; これはurlへのアクセスの結果page-sourceなHTMLソースが返されたという\n"
";; ことを意味し、関数redirect-image-linkはurlとpage-sourceを元に画像\n"
";; ファイルへのURL文字列を返すことが期待される。\n"
"(define (redirect-image-link url page-source) #f)\n"
;
